<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm31000AgendaDeTarefasFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
        
    public function partnerListQuery($filter, $params) {

        $where = [];
        foreach($params as $value) {
            if($value['value'] && $value['value'] != '') {
                if($value['operator'] == '=') {
                    $where[] = $value['columnName'].' = \''.$value['value'].'\'';
                } else if ($value['operator'] == 'IN') {
                    $quotedValues = is_array($value['value']) ? array_map(function($v) {
                        return "'" . $v . "'";
                    }, $value['value']) : [$value['value']];
                    $where[] = $value['columnName'].' IN ('.implode(', ', $quotedValues).')';
                }
            }
        }

        $where = $where ? 'WHERE '.implode(' AND ', $where) : '';

        $sql = "SELECT * FROM (SELECT SUBQUERY.*, ROW_NUMBER() OVER ( PARTITION BY NRPARCNEGOCIO ORDER BY DTPLANFILACONTA DESC ) AS RN FROM (SELECT CASE WHEN DTREALFILACONTA IS NOT NULL THEN 'CONCLUIDA' WHEN TO_CHAR(DTPLANFILACONTA, 'YYYY' ) || TO_CHAR( DTPLANFILACONTA, 'MM' ) || TO_CHAR( DTPLANFILACONTA, 'DD' ) < TO_CHAR( CURRENT_DATE, 'YYYY' ) || TO_CHAR(CURRENT_DATE, 'MM' ) || TO_CHAR(CURRENT_DATE, 'DD' ) THEN 'ATRASADA' WHEN TO_CHAR( DTPLANFILACONTA, 'YYYY' ) || TO_CHAR(DTPLANFILACONTA, 'MM' ) || TO_CHAR( DTPLANFILACONTA, 'DD' ) = TO_CHAR( CURRENT_DATE, 'YYYY' ) || TO_CHAR( CURRENT_DATE, 'MM' ) || TO_CHAR( CURRENT_DATE, 'DD' ) THEN 'HOJE' WHEN TO_CHAR( DTPLANFILACONTA, 'YYYY' ) || TO_CHAR( DTPLANFILACONTA, 'MM' ) || TO_CHAR( DTPLANFILACONTA, 'DD' ) > TO_CHAR( CURRENT_DATE, 'YYYY' ) || TO_CHAR( CURRENT_DATE, 'MM' ) || TO_CHAR( CURRENT_DATE, 'DD' ) THEN 'FUTURA' END STATUS_PRINCIPAL, CASE WHEN DTREALFILACONTA IS NOT NULL THEN 'CONCLUÍDA' WHEN DTVENCFILACONTA IS NULL OR TO_CHAR( DTVENCFILACONTA, 'YYYY/MM/DD' ) >= TO_CHAR( SYSDATE, 'YYYY/MM/DD' ) THEN 'ABERTA' ELSE 'VENCIDA' END AS STATUS, NRSEQFILACONTA, FILACONTATO.NRORG, FILACONTATO.CRM_NRORGTRAB, DSFILACONTATO, DTPLANFILACONTA, DTPLANFILACONTA AS DTHRTAREFA, TO_CHAR( DTPLANFILACONTA, 'DD/MM/YYYY' ) DATATAREFA, CDOPERREAL, DTREALFILACONTA, TO_CHAR(FILACONTATO.NRPARCNEGOCIO) NRPARCNEGOCIO, FILACONTATO.CDCLIENTE, CDFILIALCLIE, IDORIGFILACONTA, NREXECAVAL, FILACONTATO.CDFILIAL, FILACONTATO.NRCONTATO, FILACONTATO.DTINCLUSAO, FILACONTATO.DTULTATU, FILACONTATO.NRORGINCLUSAO, FILACONTATO.NRORGULTATU, FILACONTATO.CDOPERINCLUSAO, FILACONTATO.CDOPERULTATU, FILACONTATO.NRPRIORFILACONT, FILACONTATO.NRCOMUNICAPARC, FILACONTATO.NRRELACIONAPARC, FILACONTATO.IDATIVO, DSDETEFILACONTA, DTVENCFILACONTA, FILACONTATO.NRSEQCONTATO, FILACONTATO.NRSEQINTERLOCUTOR, INTER.NMINTERLOCUTOR, DSTELEFONETAREFA, DSEMAILTAREFA, FILACONTATO.NRSEQCLASSIFICATAREFA, FILACONTATO.NRSEQCAMPANHA, P.NMPRINCIPALPARC NMPARCNEGOCIO, P.CDTIPOPARCPRINCIPAL TIPOPARCPRINC, DECODE( OPOR.NRSEQOPORT, NULL, (DECODE( C.IDTIPOCONTATO, 'CHAMADO', 'CHAMADO', 'PARCEIRO' )), 'OPORTUNIDADE' ) AS TIPO, OPOR.NRSEQOPORT, OPOR.NMOPORT, OPOR.VRPREVOPORT, DECODE( OPOR.NRSEQOPORT, NULL, C.NRSEQCONTATO, OPOR.NRSEQOPORT ) AS CODIGO, DECODE( OPOR.NRSEQOPORT, NULL, C.DSREFECONT, OPOR.NRSEQOPORT || ' - ' || OPOR.NMOPORT ) AS DESCRICAO, C.DSREFECONT, CO.CDCOMUNICAPARC CDCOMUNICAPARC, O.NMOPERADOR NMOPERREAL, O.IDOPERATIVO, TAR.DSCLASSIFICATAREFA, ALT.NMOPERADOR AS NMOPERULTATU, FASENEGO.IDPERMITEFECHA, FASENEGO.NRSEQFASENEGO, FASENEGO.NMSEQFASENEGO, TERM.NRTERMOPORTUNI, TERM.NMTERMOPORTUNI, PAIS.CDPAIS, ESTADO.SGESTADO, MUNICIPIO.CDMUNICIPIO, INITCAP(PAIS.NMPAIS) NMPAIS, INITCAP(ESTADO.NMESTADO) NMESTADO, INITCAP(MUNICIPIO.NMMUNICIPIO) NMMUNICIPIO, NMORGTRAB FROM FILACONTATO JOIN CRM_ORGANIZACAO ON FILACONTATO.CRM_NRORGTRAB = CRM_ORGANIZACAO.CRM_NRORGTRAB AND FILACONTATO.NRORG = FILACONTATO.NRORG LEFT JOIN PARCNEGOCIO P ON ( FILACONTATO.NRPARCNEGOCIO = P.NRPARCNEGOCIO AND FILACONTATO.NRORG = P.NRORG ) LEFT JOIN ENDERECOPARC END ON END.NRPARCNEGOCIO = P.NRPARCNEGOCIO AND END.NRORG = P.NRORG AND END.CDTIPOENDERECO = 'PRINCIPAL' LEFT JOIN PAIS ON PAIS.CDPAIS = END.CDPAIS AND END.NRORG = PAIS.NRORG LEFT JOIN ESTADO ON ESTADO.SGESTADO = END.SGESTADO AND END.NRORG = ESTADO.NRORG AND ESTADO.CDPAIS = PAIS.CDPAIS LEFT JOIN MUNICIPIO ON MUNICIPIO.CDMUNICIPIO = END.CDMUNICIPIO AND END.NRORG = MUNICIPIO.NRORG AND MUNICIPIO.SGESTADO = ESTADO.SGESTADO AND PAIS.CDPAIS = MUNICIPIO.CDPAIS LEFT JOIN CONTATO C ON ( C.NRSEQCONTATO = FILACONTATO.NRSEQCONTATO AND C.NRORG = FILACONTATO.NRORG ) LEFT JOIN CRM_INTERLOCUTOR INTER ON INTER.NRSEQINTERLOCUTOR = FILACONTATO.NRSEQINTERLOCUTOR AND INTER.NRORG = FILACONTATO.NRORG LEFT JOIN COMUNICAPARC CO ON ( CO.NRCOMUNICAPARC = FILACONTATO.NRCOMUNICAPARC AND CO.NRORG = FILACONTATO.NRORG ) INNER JOIN OPERADOR O ON ( FILACONTATO.CDOPERREAL = O.CDOPERADOR AND FILACONTATO.NRORG = O.NRORG ) LEFT JOIN OPERADOR ALT ON FILACONTATO.CDOPERULTATU = ALT.CDOPERADOR LEFT JOIN CRM_OPORTUNI OPOR ON ( FILACONTATO.NRORG = OPOR.NRORG AND FILACONTATO.NRSEQCONTATO = OPOR.NRSEQCONTATO ) LEFT JOIN CRM_CLASSIFICATAREFA TAR ON TAR.NRORG = FILACONTATO.NRORG AND TAR.NRSEQCLASSIFICATAREFA = FILACONTATO.NRSEQCLASSIFICATAREFA LEFT JOIN CRM_FASENEGOCI FASENEGO ON OPOR.NRSEQFASENEGO = FASENEGO.NRSEQFASENEGO AND OPOR.NRORG = FASENEGO.NRORG LEFT JOIN CRM_TERMOPORTUNI TERM ON TERM.NRTERMOPORTUNI = OPOR.NRTERMOPORTUNI AND OPOR.NRORG = TERM.NRORG WHERE FILACONTATO.IDATIVO = 'S' AND ( END.NRENDERECOPARC = ( SELECT MAX(NRENDERECOPARC) FROM ENDERECOPARC WHERE NRPARCNEGOCIO = FILACONTATO.NRPARCNEGOCIO AND FILACONTATO.NRORG = ENDERECOPARC.NRORG AND CDTIPOENDERECO = 'PRINCIPAL' ) OR END.NRENDERECOPARC IS NULL ) AND ( CO.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC WHERE NRPARCNEGOCIO = FILACONTATO.NRPARCNEGOCIO AND FILACONTATO.NRORG = COMUNICAPARC.NRORG ) OR CO.NRCOMUNICAPARC IS NULL ) AND ( TRUNC(DTPLANFILACONTA) >= :P_DTINICIO AND TRUNC(DTPLANFILACONTA) <= :P_DTFIM OR :P_DTINICIO IS NULL ) AND FILACONTATO.CRM_NRORGTRAB IN ( SELECT CRM_NRORGTRAB FROM CRM_ORGREL WHERE CDOPERADOR = :P_CDOPERLOGADO )) SUBQUERY ".$where."ORDER BY DTHRTAREFA DESC ) WHERE RN = 1";

        $std = $this->connection->prepare($sql);
        $std->execute($filter);
        return $std->fetchAll();

    }
    
    
}