<?php
namespace Teknisa\CRM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\CRM\Factory\crm31000AgendaDeTarefasFactory;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;
use Zend\Validator\InArray;

class crm31000AgendaDeTarefasService {
    protected $newCode;
    protected $environment;
    protected $factory;
    
    public function __construct(crm31000AgendaDeTarefasFactory $factory, NewCode $newCode, Environment $environment) {
        $this->factory = $factory;
        $this->newCode = $newCode;
        $this->environment = $environment;
    }

    public function partnerList($params) {

        $filter = [
            "P_DTINICIO" => NULL,
            "P_DTFIM" => NULL,
            "P_CDOPERLOGADO" => NULL
        ];
        
        foreach ($params as $key => $value) {
            if(in_array($value['columnName'], array_keys($filter))) {
                $filter[$value['columnName']] = $value['value'];
                unset($params[$key]);
            }
        }

        $result = $this->factory->partnerListQuery($filter, $params);

        return $result;
    }

    
}